#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "ft_read.h"
#include "dxlib/DxLib.h"

extern int Get_GoogleMaps_Pict(double lat,double lng,int maptype);
extern void filter1(double *v1,double *v2,double *v3,double *v4,double *v5,double *v6);

void filter1(double *v1,double *v2,double *v3,double *v4,double *v5,double *v6)
{
	static int flg=0;
	static double v1out,v2out,v3out,v4out,v5out,v6out;
	const double filter_ratio=0.15;
	if (flg==0) {
		v1out= *v1; v2out= *v2; v3out= *v3; v4out= *v4; v5out= *v5; v6out= *v6;  flg=1;
	}
	v1out= *v1 *filter_ratio + v1out*(1.0-filter_ratio);
	v2out= *v2 *filter_ratio + v2out*(1.0-filter_ratio);
	v3out= *v3 *filter_ratio + v3out*(1.0-filter_ratio);
	v4out= *v4 *filter_ratio + v4out*(1.0-filter_ratio);
	v5out= *v5 *filter_ratio + v5out*(1.0-filter_ratio);
	v6out= *v6 *filter_ratio + v6out*(1.0-filter_ratio);
	*v1=v1out; *v2=v2out; *v3=v3out; *v4=v4out; *v5=v5out; *v6=v6out;
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )
{
	int Cr ;
	int GrHandle;
	char buf[1024];
	char fname[1024];
	int n,rt;
	double map_direction=0;
	int a1,a2,a3,a4,a5,a6;
	double d1,d2,d3,d4,d5,d6;
	double mx,my,mz,ax,ay,az;
	double mx_offset = 0;
	double my_offset = 0;
	double lat,lng;
	
	if (fti2c_test_init()!=0) { // ZT[̏
		MessageBox(0,"Sensor not found.",0,0); return 1;
	}
	
	// EChE[hɕύX
	ChangeWindowMode( TRUE ) ;
	SetMainWindowText( "Map" ) ;
	if ( DxLib_Init() == -1 ) {	// cwCu
		 return -1;	// G[N璼ɏI
	}
	SetDrawScreen( DX_SCREEN_BACK ) ;
	SetWindowSizeChangeEnableFlag( TRUE );
	DrawString( 10 , 10 , "Loading maps.." , GetColor( 127 , 127 , 127 ) ) ;
	ScreenFlip();
	lat = 35.1704;   lng = 136.882; // Éẅܓx,ox
	if (Get_GoogleMaps_Pict(lat,lng,3)== -1) { // Googlen}摜BĂ
		MessageBox(0,"Map picture download error (Cannot access google.com)",0,0);
	}
	strcpy(fname,"map_pict.png");
	GrHandle=LoadGraph(fname);
	
	while (1) {
		fti2c_test_measure(&a1,&a2,&a3,&a4,&a5,&a6);
		d1=a1; d2=a2; d3=a3; d4=a4; d5=a5; d6=a6;
		filter1(&d1,&d2,&d3,&d4,&d5,&d6);
		mx=d1; my=d2;
		mx=mx-mx_offset; my=my-my_offset;
		map_direction=90-atan2(my,mx)*180/3.1415926535;
		if (map_direction<0) { map_direction+=360; }
		SetDrawArea( 0 , 0 , 640 , 480 ) ;
		ClearDrawScreen();
		SetDrawArea( 0 , 0 , 401 , 401 ) ;
		DrawRotaGraph2( 200,200 /* \ʒu-S */ ,  300, 300  /* 摜f[^̉]S */
					, 1.00 /* g */ , map_direction /180.0 * 3.14159265 /* ]p */
					, GrHandle, FALSE, FALSE);
		SetDrawArea( 0 , 0 , 640 , 480 ) ;
		DrawString( 420 ,  0 , "Magnetic sensor"  , GetColor( 255 , 255 , 255 ) ) ;
		sprintf(buf," x=%d",a1);
		DrawString( 420 , 20 , buf , GetColor( 255 , 255 , 255 ) ) ;
		sprintf(buf," y=%d",a2);
		DrawString( 420 , 40 , buf , GetColor( 255 , 255 , 255 ) ) ;
		sprintf(buf," z=%d",a3);
		DrawString( 420 , 60 , buf , GetColor( 255 , 255 , 255 ) ) ;
		DrawString( 420 ,100 , "Acceleration sensor"  , GetColor( 255 , 255 , 255 ) ) ;
		sprintf(buf," x=%d",a4);
		DrawString( 420 ,120 , buf , GetColor( 255 , 255 , 255 ) ) ;
		sprintf(buf," y=%d",a5);
		DrawString( 420 ,140 , buf , GetColor( 255 , 255 , 255 ) ) ;
		sprintf(buf," z=%d",a6);
		DrawString( 420 ,160 , buf , GetColor( 255 , 255 , 255 ) ) ;
		DrawString( 0   ,460 , "[ESC]-Quit"  , GetColor( 255 , 255 , 255 ) ) ;
		ScreenFlip();
		if (ProcessMessage() == -1) { break; }
		if( CheckHitKey( KEY_INPUT_ESCAPE ) != 0 ) { break; }// ESCL[
		Sleep(100);
	}
	DxLib_End() ;				// cwCugp̏I

	return 0 ;					// \tg̏I
}
